--dofile"sys/lua/timerex.txt" by 0x45525A41 http://www.unrealsoftware.de/files_show.php?file=13759
__timerArg={}

function timerEx(ms,func,count,...)
	count=count or 1
	local tmpfunc,id="",0
	for i=1,8 do
		local rand=math.random(0,2)
		if rand==0 then
			tmpfunc=tmpfunc..string.char(math.random(65,90))
		elseif rand==1 then
			tmpfunc=tmpfunc..string.char(math.random(97,112))
		else
			tmpfunc=tmpfunc..math.random(0,9)
		end
	end
	table.insert(__timerArg,{type(func),tmpfunc,func,{...}})
	for n,v in pairs(__timerArg) do
		if v[2]==tmpfunc then
			id=n
			break
		end
	end
	_G[tmpfunc]=function(id)
		id=tonumber(id)
		if __timerArg[id][1]=="function" then
			__timerArg[id][3](unpack(__timerArg[id][4]))
		elseif __timerArg[id][1]=="string" or __timerArg[id][1]=="number" then
			_G[__timerArg[id][3]](unpack(__timerArg[id][4]))
		end
		_G[__timerArg[id][2]]=nil
		__timerArg[id]=nil
	end
	timer(ms,tmpfunc,id,count)
	return id
end

function freetimerEx(id)
	if __timerArg[id]~=nil then
		freetimer(__timerArg[id][2],id)
		__timerArg[id]=nil
		return true
	end
	return false
end
---------------------------------------------------------------------------------------------------
bombs={key={},id={},img={},glow={},x={},y={},state={},bombexploss={},deadlytiles={}}
bombcircle={x={3,4,5,6,7,8,9,10,11,3,4,5,6,7,8,9,10,11,3,3,3,3,3,11,11,11,11,11},y={3,3,3,3,3,3,3,3,3,9,9,9,9,9,9,9,9,9,4,5,6,7,8,4,5,6,7,8}}
bombcirclebool=false
key=1
bombtime_toexplode=2500
throwbombtime_toexplode=1000

function itemcol(id,path,x,y,mode,onlyid)
if onlyid==nil then onlyid=false end
if onlyid then
	if path=="gfx/hud_dot.bmp" or path=="gfx/hud_arrow.bmp" then
	nowimage=image(path.."<b>",x,y,mode,id)
	else
		if path=="gfx/gui_c.bmp<b>" then
		nowimage=image(path,x,y,mode,id)
		else
		nowimage=image(path.."<m>",x,y,mode,id)
		end
	end
else
	if path=="gfx/hud_dot.bmp" or path=="gfx/hud_arrow.bmp" then
	nowimage=image(path.."<b>",x,y,mode)
	else
		if path=="gfx/gui_c.bmp<b>" then
		nowimage=image(path,x,y,mode)
		else
		nowimage=image(path.."<m>",x,y,mode)
		end
	end
end
if path=="gfx/gui_c.bmp<b>" then
	imagescale(nowimage,0.8,0.8)
end
imageblend(nowimage,0)
	if id==1 then
	imagecolor(nowimage,141,28,26)
	elseif id==2 then
	imagecolor(nowimage,70,127,76)
	elseif id==3 then
	imagecolor(nowimage,41,68,156)
	elseif id==4 then
	imagecolor(nowimage,119,64,133)
	end
return nowimage
end

function addbomb(id)
local x=player(id,"tilex")
local y=player(id,"tiley")

bombs.key[#bombs.key+1]=key
bombs.id[#bombs.id+1]=id
bombs.img[#bombs.img+1]=image("gfx/weapons/bomb.bmp<m>",x*32+16,y*32+16,0)
bombs.glow[#bombs.glow+1]=itemcol(id,"gfx/shadow.bmp<b>",x*32+14,y*32+22,0)
imageblend(bombs.glow[#bombs.glow],1)
imagescale(bombs.glow[#bombs.glow],0.5,0.5)
timer(200,"bombblink",bombs.glow[#bombs.glow],math.floor(bombtime_toexplode/200))
bombs.x[#bombs.x+1]=x
bombs.y[#bombs.y+1]=y
bombs.state[#bombs.state+1]=0
timer(bombtime_toexplode,"bombexplode",key)
key=key+1
end

function bombexplode(key,returnBomb)
if returnBomb==nil then returnBomb=true end
if noDir==nil then noDir=0 end --1=left,2=right,3=up,4=down
local key=tonumber(key)
local goon=false
	for thisbomb,bombkey in pairs(bombs.key) do
		if bombkey==key and bombs.state[thisbomb]~=6 then
			bombs.state[thisbomb]=6
			goon=true
			bombs.bombexploss[thisbomb]=drawexplo(thisbomb)
			bombs.deadlytiles[thisbomb]=setdeadtiles(thisbomb,noDir)
			if returnBomb then
				timer(500,"givebomb",bombs.id[thisbomb])
			end
			timer(500,"removebombtables",key)
			break
		end
	end
	if goon then
	local ran=math.random()
	if ran<0.166 then
		parse("sv_sound weapons/explode1.wav")
	elseif ran<0.333 then
		parse("sv_sound weapons/explode2.wav")
	elseif ran<0.5 then
		parse("sv_sound weapons/explode3.wav")
	elseif ran<0.666 then
		parse("sv_sound weapons/explode4.wav")
	elseif ran<0.833 then
		parse("sv_sound weapons/explode5.wav")
	else
		parse("sv_sound weapons/explode6.wav")
	end
	end
end

function clearexplo(thisbomb)
	for i=1,#bombs.bombexploss[thisbomb].left do
		freeimage(bombs.bombexploss[thisbomb].left[i])
	end
	for i=1,#bombs.bombexploss[thisbomb].right do
		freeimage(bombs.bombexploss[thisbomb].right[i])
	end
	for i=1,#bombs.bombexploss[thisbomb].up do
		freeimage(bombs.bombexploss[thisbomb].up[i])
	end
	for i=1,#bombs.bombexploss[thisbomb].down do
		freeimage(bombs.bombexploss[thisbomb].down[i])
	end
	freeimage(bombs.bombexploss[thisbomb].center)
	table.remove(bombs.bombexploss,thisbomb)
	table.remove(bombs.deadlytiles,thisbomb)
end

function setdeadtiles(thisbomb,noDir)
local deadlytilespart={x={},y={}}
local x=bombs.x[thisbomb]
local y=bombs.y[thisbomb]
deadlytilespart.x[#deadlytilespart.x+1]=x
deadlytilespart.y[#deadlytilespart.y+1]=y
	for _,p in pairs(player(0,"team1living")) do
		if player(p,"tilex")==x and player(p,"tiley")==y then
			hurt(p)
		end
	end
	for s=1, playerskill.eny[bombs.id[thisbomb]]+1 do--right
		if entity(bombs.x[thisbomb]+s,bombs.y[thisbomb],"typename") == "Env_Breakable" or tile(bombs.x[thisbomb]+s,bombs.y[thisbomb],"wall") then break end
		deadlytilespart.x[#deadlytilespart.x+1]=x+s
		deadlytilespart.y[#deadlytilespart.y+1]=y
		for _,p in pairs(player(0,"team1living")) do
			if player(p,"tilex")==x+s and player(p,"tiley")==y then
				hurt(p)
			end
		end
		for bombindex,_ in pairs(bombs.id) do
			if bombs.x[bombindex]==bombs.x[thisbomb]+s and bombs.y[bombindex]==bombs.y[thisbomb] and bombindex~= thisbomb then
				bombexplode(bombs.key[bombindex])
				freetimer("bombexplode",bombs.key[bombindex])
			end
		end
		if map==2 then
			for ringposindex,_ in pairs(bombcircle.x) do
				if bombcircle.x[ringposindex]==bombs.x[thisbomb]+s and bombcircle.y[ringposindex]==bombs.y[thisbomb] then
					for i=1,#bombcircleimg do
						imagecolor(bombcircleimg[i],255,255,0)
					end
					bombcirclebool=true
					freetimer(500,"ringout")
					timer(500,"ringout")
				end
			end
		end
	end
	for s=1, playerskill.eny[bombs.id[thisbomb]]+1 do--left
		if entity(bombs.x[thisbomb]-s,bombs.y[thisbomb],"typename") == "Env_Breakable" or tile(bombs.x[thisbomb]-s,bombs.y[thisbomb],"wall") then break end
		deadlytilespart.x[#deadlytilespart.x+1]=x-s
		deadlytilespart.y[#deadlytilespart.y+1]=y
		for _,p in pairs(player(0,"team1living")) do
			if player(p,"tilex")==x-s and player(p,"tiley")==y then
				hurt(p)
			end
		end
		for bombindex,_ in pairs(bombs.id) do
			if bombs.x[bombindex]==bombs.x[thisbomb]-s and bombs.y[bombindex]==bombs.y[thisbomb] and bombindex~= thisbomb then
				bombexplode(bombs.key[bombindex])
				freetimer("bombexplode",bombs.key[bombindex])
			end
		end
		if map==2 then
			for ringposindex,_ in pairs(bombcircle.x) do
				if bombcircle.x[ringposindex]==bombs.x[thisbomb]-s and bombcircle.y[ringposindex]==bombs.y[thisbomb] then
					for i=1,#bombcircleimg do
						imagecolor(bombcircleimg[i],255,255,0)
					end
					bombcirclebool=true
					freetimer(500,"ringout")
					timer(500,"ringout")
				end
			end
		end
	end
	for s=1, playerskill.eny[bombs.id[thisbomb]]+1 do--down
		if entity(bombs.x[thisbomb],bombs.y[thisbomb]+s,"typename") == "Env_Breakable" or tile(bombs.x[thisbomb],bombs.y[thisbomb]+s,"wall") then break end
		deadlytilespart.x[#deadlytilespart.x+1]=x
		deadlytilespart.y[#deadlytilespart.y+1]=y+s
		for _,p in pairs(player(0,"team1living")) do
			if player(p,"tilex")==x and player(p,"tiley")==y+s then
				hurt(p)
			end
		end
		for bombindex,_ in pairs(bombs.id) do
			if bombs.x[bombindex]==bombs.x[thisbomb] and bombs.y[bombindex]==bombs.y[thisbomb]+s and bombindex~= thisbomb then
				bombexplode(bombs.key[bombindex])
				freetimer("bombexplode",bombs.key[bombindex])
			end
		end
		if map==2 then
			for ringposindex,_ in pairs(bombcircle.x) do
				if bombcircle.x[ringposindex]==bombs.x[thisbomb] and bombcircle.y[ringposindex]==bombs.y[thisbomb]+s then
					for i=1,#bombcircleimg do
						imagecolor(bombcircleimg[i],255,255,0)
					end
					bombcirclebool=true
					freetimer(500,"ringout")
					timer(500,"ringout")
				end
			end
		end
	end
	for s=1, playerskill.eny[bombs.id[thisbomb]]+1 do--up
		if entity(bombs.x[thisbomb],bombs.y[thisbomb]-s,"typename") == "Env_Breakable" or tile(bombs.x[thisbomb],bombs.y[thisbomb]-s,"wall") then break end
		deadlytilespart.x[#deadlytilespart.x+1]=x
		deadlytilespart.y[#deadlytilespart.y+1]=y-s
		for _,p in pairs(player(0,"team1living")) do
			if player(p,"tilex")==x and player(p,"tiley")==y-s then
				hurt(p)
			end
		end
		for bombindex,_ in pairs(bombs.id) do
			if bombs.x[bombindex]==bombs.x[thisbomb] and bombs.y[bombindex]==bombs.y[thisbomb]-s and bombindex~= thisbomb then
				bombexplode(bombs.key[bombindex])
				freetimer("bombexplode",bombs.key[bombindex])
			end
		end
		if map==2 then
			for ringposindex,_ in pairs(bombcircle.x) do
				if bombcircle.x[ringposindex]==bombs.x[thisbomb] and bombcircle.y[ringposindex]==bombs.y[thisbomb]-s then
					for i=1,#bombcircleimg do
						imagecolor(bombcircleimg[i],255,255,0)
					end
					bombcirclebool=true
					freetimer(500,"ringout")
					timer(500,"ringout")
				end
			end
		end
	end
	return deadlytilespart
end

function drawexplo(thisbomb)
freetimer("bombblink",thisbomb)
freetimer("bombblinkoff",thisbomb)
freeimage(bombs.glow[thisbomb])
freeimage(bombs.img[thisbomb])
local bombexplos={left={},right={},up={},down={},center=nil}
bombexplos.center=itemcol(bombs.id[thisbomb],"<tile:8>",bombs.x[thisbomb]*32,bombs.y[thisbomb]*32,3)
	for s=1, playerskill.eny[bombs.id[thisbomb]] do--right
		if entity(bombs.x[thisbomb]+s,bombs.y[thisbomb],"typename") == "Env_Breakable" then
			bombexplos.right[#bombexplos.right+1]=itemcol(bombs.id[thisbomb],"<tile:9>",bombs.x[thisbomb]*32+32*s+32,bombs.y[thisbomb]*32,3)
			imagepos(bombexplos.right[#bombexplos.right],bombs.x[thisbomb]*32+32*s+32,bombs.y[thisbomb]*32,90)
			break
		end
		if tile(bombs.x[thisbomb]+s,bombs.y[thisbomb],"wall") then break end
		bombexplos.right[#bombexplos.right+1]=itemcol(bombs.id[thisbomb],"<tile:10>",bombs.x[thisbomb]*32+32*s+32,bombs.y[thisbomb]*32,3)
		imagepos(bombexplos.right[#bombexplos.right],bombs.x[thisbomb]*32+32*s+32,bombs.y[thisbomb]*32,90)	
		if s==playerskill.eny[bombs.id[thisbomb]] then
			if tile(bombs.x[thisbomb]+s+1,bombs.y[thisbomb],"wall")==false then
				bombexplos.right[#bombexplos.right+1]=itemcol(bombs.id[thisbomb],"<tile:9>",bombs.x[thisbomb]*32+32*s+64,bombs.y[thisbomb]*32,3)
				imagepos(bombexplos.right[#bombexplos.right],bombs.x[thisbomb]*32+64+32*s,bombs.y[thisbomb]*32,90)
			elseif entity(bombs.x[thisbomb]+s+1,bombs.y[thisbomb],"typename") == "Env_Breakable" then
				bombexplos.right[#bombexplos.right+1]=itemcol(bombs.id[thisbomb],"<tile:9>",bombs.x[thisbomb]*32+32*s+64,bombs.y[thisbomb]*32,3)
				imagepos(bombexplos.right[#bombexplos.right],bombs.x[thisbomb]*32+64+32*s,bombs.y[thisbomb]*32,90)
			end
		end
	end
	for s=1, playerskill.eny[bombs.id[thisbomb]] do--left
		if entity(bombs.x[thisbomb]-s,bombs.y[thisbomb],"typename") == "Env_Breakable" then
			bombexplos.left[#bombexplos.left+1]=itemcol(bombs.id[thisbomb],"<tile:9>",bombs.x[thisbomb]*32-32*s,bombs.y[thisbomb]*32+32,3)
			imagepos(bombexplos.left[#bombexplos.left],bombs.x[thisbomb]*32-32*s,bombs.y[thisbomb]*32+32,270)
			break
		end
		if tile(bombs.x[thisbomb]-s,bombs.y[thisbomb],"wall") then break end
		bombexplos.left[#bombexplos.left+1]=itemcol(bombs.id[thisbomb],"<tile:10>",bombs.x[thisbomb]*32-32*s,bombs.y[thisbomb]*32+32,3)
		imagepos(bombexplos.left[#bombexplos.left],bombs.x[thisbomb]*32-32*s,bombs.y[thisbomb]*32+32,270)
		if s==playerskill.eny[bombs.id[thisbomb]] then
			if tile(bombs.x[thisbomb]-s-1,bombs.y[thisbomb],"wall")==false then
				bombexplos.left[#bombexplos.left+1]=itemcol(bombs.id[thisbomb],"<tile:9>",bombs.x[thisbomb]*32-32*s-32,bombs.y[thisbomb]*32+32,3)
				imagepos(bombexplos.left[#bombexplos.left],bombs.x[thisbomb]*32-32*s-32,bombs.y[thisbomb]*32+32,270)
			elseif entity(bombs.x[thisbomb]-s-1,bombs.y[thisbomb],"typename") == "Env_Breakable" then
				bombexplos.left[#bombexplos.left+1]=itemcol(bombs.id[thisbomb],"<tile:9>",bombs.x[thisbomb]*32-32*s-32,bombs.y[thisbomb]*32+32,3)
				imagepos(bombexplos.left[#bombexplos.left],bombs.x[thisbomb]*32-32*s-32,bombs.y[thisbomb]*32+32,270)
			end
		end
	end
	for s=1, playerskill.eny[bombs.id[thisbomb]] do--down
		if entity(bombs.x[thisbomb],bombs.y[thisbomb]+s,"typename") == "Env_Breakable" then
			bombexplos.down[#bombexplos.down+1]=itemcol(bombs.id[thisbomb],"<tile:9>",bombs.x[thisbomb]*32+32,bombs.y[thisbomb]*32+32*s+32,3)
			imagepos(bombexplos.down[#bombexplos.down],bombs.x[thisbomb]*32+32,bombs.y[thisbomb]*32+32*s+32,180)
			break
		end
		if tile(bombs.x[thisbomb],bombs.y[thisbomb]+s,"wall") then break end
		bombexplos.down[#bombexplos.down+1]=itemcol(bombs.id[thisbomb],"<tile:10>",bombs.x[thisbomb]*32,bombs.y[thisbomb]*32+32*s,3)
		if s==playerskill.eny[bombs.id[thisbomb]] then
			if tile(bombs.x[thisbomb],bombs.y[thisbomb]+s+1,"wall")==false then
				bombexplos.down[#bombexplos.down+1]=itemcol(bombs.id[thisbomb],"<tile:9>",bombs.x[thisbomb]*32+32,bombs.y[thisbomb]*32+32*s+32,3)
				imagepos(bombexplos.down[#bombexplos.down],bombs.x[thisbomb]*32+32,bombs.y[thisbomb]*32+32*s+64,180)
			elseif entity(bombs.x[thisbomb],bombs.y[thisbomb]+s+1,"typename") == "Env_Breakable" then
				bombexplos.down[#bombexplos.down+1]=itemcol(bombs.id[thisbomb],"<tile:9>",bombs.x[thisbomb]*32+32,bombs.y[thisbomb]*32+32*s+32,3)
				imagepos(bombexplos.down[#bombexplos.down],bombs.x[thisbomb]*32+32,bombs.y[thisbomb]*32+32*s+64,180)
			end
		end	
	end
	for s=1, playerskill.eny[bombs.id[thisbomb]] do--up
		if entity(bombs.x[thisbomb],bombs.y[thisbomb]-s,"typename") == "Env_Breakable" then
			bombexplos.up[#bombexplos.up+1]=itemcol(bombs.id[thisbomb],"<tile:9>",bombs.x[thisbomb]*32,bombs.y[thisbomb]*32-32*s,3)
			break
		end
		if tile(bombs.x[thisbomb],bombs.y[thisbomb]-s,"wall") then break end
		bombexplos.up[#bombexplos.up+1]=itemcol(bombs.id[thisbomb],"<tile:10>",bombs.x[thisbomb]*32,bombs.y[thisbomb]*32-32*s,3)
		if s==playerskill.eny[bombs.id[thisbomb]] then
			if tile(bombs.x[thisbomb],bombs.y[thisbomb]-(s+1),"wall")==false then
				bombexplos.up[#bombexplos.up+1]=itemcol(bombs.id[thisbomb],"<tile:9>",bombs.x[thisbomb]*32,bombs.y[thisbomb]*32-32-32*s,3)
			elseif entity(bombs.x[thisbomb],bombs.y[thisbomb]-s-1,"typename") == "Env_Breakable" then
				bombexplos.up[#bombexplos.up+1]=itemcol(bombs.id[thisbomb],"<tile:9>",bombs.x[thisbomb]*32,bombs.y[thisbomb]*32-32-32*s,3)
			end
		end
	end
	return bombexplos
end

function destroybreakable(thisbomb)
	for s=1, playerskill.eny[bombs.id[thisbomb]]+1 do--right
		if entity(bombs.x[thisbomb]+s,bombs.y[thisbomb],"typename") == "Env_Breakable" then
			parse("trigger "..entity(bombs.x[thisbomb]+s,bombs.y[thisbomb],"name"))
			break
		end
		if tile(bombs.x[thisbomb]+s,bombs.y[thisbomb],"wall") then break end
	end
	for s=1, playerskill.eny[bombs.id[thisbomb]]+1 do--left
		if entity(bombs.x[thisbomb]-s,bombs.y[thisbomb],"typename") == "Env_Breakable" then
			parse("trigger "..entity(bombs.x[thisbomb]-s,bombs.y[thisbomb],"name"))
			break
		end
		if tile(bombs.x[thisbomb]-s,bombs.y[thisbomb],"wall") then break end
	end
	for s=1, playerskill.eny[bombs.id[thisbomb]]+1 do--down
		if entity(bombs.x[thisbomb],bombs.y[thisbomb]+s,"typename") == "Env_Breakable" then
			parse("trigger "..entity(bombs.x[thisbomb],bombs.y[thisbomb]+s,"name"))
			break
		end
		if tile(bombs.x[thisbomb],bombs.y[thisbomb]+s,"wall") then break end
	end
	for s=1, playerskill.eny[bombs.id[thisbomb]]+1 do--up
		if entity(bombs.x[thisbomb],bombs.y[thisbomb]-s,"typename") == "Env_Breakable" then
			parse("trigger "..entity(bombs.x[thisbomb],bombs.y[thisbomb]-s,"name"))
			break
		end
		if tile(bombs.x[thisbomb],bombs.y[thisbomb]-s,"wall") then break end
	end
end

function removebombtables(key)
local key=tonumber(key)
for thisbomb,bombkey in pairs(bombs.key) do
	if bombkey==key then
		destroybreakable(thisbomb)
		clearexplo(thisbomb)
		if #bombs.key~=#bombs.x then
		msg("255000000ERROR: Round have to be restarted@C")
		timer(5000,"parse","endround 0")
		end
		table.remove(bombs.key,thisbomb)
		table.remove(bombs.id,thisbomb)
		table.remove(bombs.img,thisbomb)
		table.remove(bombs.glow,thisbomb)
		table.remove(bombs.x,thisbomb)
		table.remove(bombs.y,thisbomb)
		table.remove(bombs.state,thisbomb)
		break
	end
end
end

function bombmove(key)
key=tonumber(key)
for thisbomb,bombkey in pairs(bombs.key) do
	if bombkey==key then
		local dir=bombs.state[thisbomb]
		local x=bombs.x[thisbomb]
		local y=bombs.y[thisbomb]
		if dir==1 then
			if checkmove(x-1,y) then
				tween_move(bombs.img[thisbomb],100,x*32-16,y*32+16)
				tween_move(bombs.glow[thisbomb],100,x*32-18,y*32+22)
				timer(50,"newbombpos",key)
				timer(100,"bombmove",key)
			end
		elseif dir==2 then
			if checkmove(x+1,y) then
				tween_move(bombs.img[thisbomb],100,x*32+48,y*32+16)
				tween_move(bombs.glow[thisbomb],100,x*32+46,y*32+22)
				timer(50,"newbombpos",key)
				timer(100,"bombmove",key)
			end
		elseif dir==3 then
			if checkmove(x,y-1) then
				tween_move(bombs.img[thisbomb],100,x*32+16,y*32-16)
				tween_move(bombs.glow[thisbomb],100,x*32+14,y*32-10)
				timer(50,"newbombpos",key)
				timer(100,"bombmove",key)
			end
		elseif dir==4 then
			if checkmove(x,y+1) then
				tween_move(bombs.img[thisbomb],100,x*32+16,y*32+48)
				tween_move(bombs.glow[thisbomb],100,x*32+14,y*32+54)
				timer(50,"newbombpos",key)
				timer(100,"bombmove",key)
			end	
		end
	break
	end
end
end

function checkmove(x,y,thisbomb)
local isfree=true
	for i=1,#bombs.id do
		if x==bombs.x[i] and y==bombs.y[i] and i~=thisbomb then
			isfree=false
		end
	end
	if tile(x,y,"wall") then
		isfree=false
	end
return isfree
end

function newbombpos(key)
key=tonumber(key)
for thisbomb,bombkey in pairs(bombs.key) do
	if bombkey==key then
		local dir=bombs.state[thisbomb]
		if dir==1 then
			bombs.x[thisbomb]=bombs.x[thisbomb]-1
		elseif dir==2 then
			bombs.x[thisbomb]=bombs.x[thisbomb]+1
		elseif dir==3 then
			bombs.y[thisbomb]=bombs.y[thisbomb]-1
		elseif dir==4 then
			bombs.y[thisbomb]=bombs.y[thisbomb]+1
		end
	break
	end
end
end

function takebomb(id,thisbomb)
freetimer("bombexplode",bombs.key[thisbomb])
freetimer("bombblink",thisbomb)
freetimer("bombblinkoff",thisbomb)
freeimage(bombs.img[thisbomb])
freeimage(bombs.glow[thisbomb])
bombs.x[thisbomb]=-1
bombs.y[thisbomb]=-1
bombs.state[thisbomb]=5
end

function throwbomb(id,thisbomb)
local x=player(id,"tilex")
local y=player(id,"tiley")
local rot=player(id,"rot")
	
	
bombs.img[thisbomb]=image("gfx/weapons/bomb.bmp<m>",x*32+16,y*32+16,3)
bombs.glow[thisbomb]=itemcol(id,"gfx/shadow.bmp<b>",x*32+14,y*32+22,3)
imageblend(bombs.glow[thisbomb],1)
imagescale(bombs.glow[thisbomb],0.5,0.5)
timer(200,"bombblink",bombs.glow[#bombs.glow],math.floor(throwbombtime_toexplode/200))
bombs.x[thisbomb]=x
bombs.y[thisbomb]=y
bombs.state[thisbomb]=7

	if rot<-45 and rot>=-135 then --left
		movethrowbomb(thisbomb,1)
	elseif rot>45 and rot<=135 then--right
		movethrowbomb(thisbomb,2)
	elseif rot>=-45 and rot<=45 then--top
		movethrowbomb(thisbomb,3)
	elseif rot<-135 or rot>135 then --bot
		movethrowbomb(thisbomb,4)
	end
end

function movethrowbomb(thisbomb,rot)
local x =bombs.x[thisbomb]
local y =bombs.y[thisbomb]
local i=1
	if rot==1 then
		repeat 
			if x-i>0 then i=i+1 else i=x-14 end
		until checkmove(x-i,y,thisbomb) 
		if i>0 then 
			tween_move(bombs.img[thisbomb],100*i,x*32-32*i+16,y*32+16)
			tween_move(bombs.glow[thisbomb],100*i,x*32-32*i+14,y*32+22)
			bombs.x[thisbomb]=bombs.x[thisbomb]-i
			timerEx(throwbombtime_toexplode+100*i,"bombexplode",1,bombs.key[thisbomb],false)
		else
			tween_move(bombs.img[thisbomb],100*x,0,y*32+16)
			tween_move(bombs.glow[thisbomb],100*x,0,y*32+22)
			bombs.x[thisbomb]=bombs.x[thisbomb]-i
			tmp=timerEx(100*x,otherside,1,bombs.key[thisbomb],i,x,y,rot)
		end
	end
	if rot==2 then
		repeat
			if x+i<14 then i=i+1 else i=-x end
		until checkmove(x+i,y,thisbomb)
		if i>0 then 
			tween_move(bombs.img[thisbomb],100*i,x*32+32*i+16,y*32+16)
			tween_move(bombs.glow[thisbomb],100*i,x*32+32*i+14,y*32+22)
			bombs.x[thisbomb]=bombs.x[thisbomb]+i
			timerEx(throwbombtime_toexplode+100*i,"bombexplode",1,bombs.key[thisbomb],false)
		else
			tween_move(bombs.img[thisbomb],100*(14-x),448,y*32+16)
			tween_move(bombs.glow[thisbomb],100*(14-x),448,y*32+22)
			bombs.x[thisbomb]=bombs.x[thisbomb]+i
			tmp=timerEx(100*(14-x),otherside,1,bombs.key[thisbomb],i,x,y,rot)
		end
	end
	if rot==3 then
		repeat
			if y-i>0 then i=i+1 else i=y-12 end
		until checkmove(x,y-i,thisbomb)
		if i>0 then 
			tween_move(bombs.img[thisbomb],100*i,x*32+16,y*32-32*i+16)
			tween_move(bombs.glow[thisbomb],100*i,x*32+14,y*32-32*i+22)
			bombs.y[thisbomb]=bombs.y[thisbomb]-i
			timerEx(throwbombtime_toexplode+100*i,"bombexplode",1,bombs.key[thisbomb],false)
		else
			tween_move(bombs.img[thisbomb],100*y,x*32+16,0)
			tween_move(bombs.glow[thisbomb],100*y,x*32+14,0)
			bombs.y[thisbomb]=bombs.y[thisbomb]-i
			tmp=timerEx(100*y,otherside,1,bombs.key[thisbomb],i,x,y,rot)
		end
	end
	if rot==4 then
		repeat
			if y+i<12 then i=i+1 else i=-y end
		until checkmove(x,y+i,thisbomb) 
		if i>0 then 
			tween_move(bombs.img[thisbomb],100*i,x*32+16,y*32+32*i+16)
			tween_move(bombs.glow[thisbomb],100*i,x*32+14,y*32+32*i+22)
			bombs.y[thisbomb]=bombs.y[thisbomb]+i
			timerEx(throwbombtime_toexplode+100*i,"bombexplode",1,bombs.key[thisbomb],false)
		else
			tween_move(bombs.img[thisbomb],100*(12-y),x*32+16,384)
			tween_move(bombs.glow[thisbomb],100*(12-y),x*32+14,384)
			bombs.y[thisbomb]=bombs.y[thisbomb]+i
			tmp=timerEx(100*(12-y),otherside,1,bombs.key[thisbomb],i,x,y,rot)
		end
	end
end

function otherside(key,i,x,y,rot)
for thisbomb,bombkey in pairs(bombs.key) do
	if bombkey==key then
		if rot==1 then
			imagepos(bombs.img[thisbomb],448,y*32+16,0)
			imagepos(bombs.glow[thisbomb],448,y*32+22,0)
			tween_move(bombs.img[thisbomb],100*-i,x*32-32*i+16,y*32+16)
			tween_move(bombs.glow[thisbomb],100*-i,x*32-32*i+14,y*32+22)
			timerEx(throwbombtime_toexplode+100*-i,"bombexplode",1,key,false)
		end
		if rot==2 then
			imagepos(bombs.img[thisbomb],0,y*32+16,0)
			imagepos(bombs.glow[thisbomb],0,y*32+22,0)
			tween_move(bombs.img[thisbomb],100*-i,x*32+32*i+16,y*32+16)
			tween_move(bombs.glow[thisbomb],100*-i,x*32+32*i+14,y*32+22)
			timerEx(throwbombtime_toexplode+100*-i,"bombexplode",1,key,false)
		end
		if rot==3 then
			imagepos(bombs.img[thisbomb],x*32+16,384,0)
			imagepos(bombs.glow[thisbomb],x*32+14,384,0)
			tween_move(bombs.img[thisbomb],100*-i,x*32+16,y*32-32*i+16)
			tween_move(bombs.glow[thisbomb],100*-i,x*32+14,y*32-32*i+22)
			timerEx(throwbombtime_toexplode+100*-i,"bombexplode",1,key,false)
		end
		if rot==4 then
			imagepos(bombs.img[thisbomb],x*32+16,0,0)
			imagepos(bombs.glow[thisbomb],x*32+14,0,0)
			tween_move(bombs.img[thisbomb],100*-i,x*32+16,y*32+32*i+16)
			tween_move(bombs.glow[thisbomb],100*-i,x*32+14,y*32+32*i+22)
			timerEx(throwbombtime_toexplode+100*-i,"bombexplode",1,key,false)
		end
	break
	end
end
end

addhook("movetile","bomb_movetile")
function bomb_movetile(id,x,y)
	if #bombs.deadlytiles~=0 then
		for i=1,#bombs.deadlytiles do
			for ix=1,#bombs.deadlytiles[i].x do
				if x==bombs.deadlytiles[i].x[ix] and y==bombs.deadlytiles[i].y[ix] then
					hurt(id)
				end
			end
		end
	end
	if map==2 and bombcirclebool then
		for r,ringcount in pairs(bombcircle.x) do
			if bombcircle.x[r]==x and bombcircle.y[r]==y then
				hurt(id)
			end
		end
	end
end

function ringout()
bombcirclebool=false
	for i=1,#bombcircleimg do
		imagecolor(bombcircleimg[i],255,255,255)
	end
end

addhook("ms100","bomb_ms100")
function bomb_ms100()
	if map==2 and bombcirclebool then
		for _,id in pairs(player(0,"team1living")) do
			for r,ringcount in pairs(bombcircle.x) do
				if bombcircle.x[r]==player(id,"tilex") and bombcircle.y[r]==player(id,"tiley") then
					hurt(id)
				end
			end
		end
	end
end

function bombblink(glowimg)
imagealpha(glowimg,0.2)
timer(50,"bombblinkoff",glowimg)
end

function bombblinkoff(glowimg)
imagealpha(glowimg,1.0)
end
